import * as auth from "@azure/core-auth";
import * as authArm from "@azure/arm-authorization";
import * as t from "io-ts";
export declare const listOf: <TType extends t.Mixed>(
  item: TType,
) => t.ArrayC<TType>;
export declare type ClientArgs = readonly [auth.TokenCredential, string];
export declare const upsertRoleAssignment: (
  clientOrArgs: ClientArgs | authArm.AuthorizationManagementClient,
  scope: string,
  roleDefinitionUuId: string,
  principalId: string,
) => Promise<{
  type: "Microsoft.Authorization/roleAssignments";
  id: string;
  name: string;
  scope: string;
  roleDefinitionId: string;
  principalId: string;
  principalType:
    | "User"
    | "Group"
    | "ServicePrincipal"
    | "Unknown"
    | "DirectoryRoleTemplate"
    | "ForeignGroup"
    | "Application"
    | "MSI"
    | "DirectoryObjectOrGroup"
    | "Everyone";
}>;
declare global {
  interface ArrayConstructor {
    isArray(
      arg: ReadonlyArray<unknown> | unknown,
    ): arg is ReadonlyArray<unknown>;
  }
}
