import * as auth from "@azure/core-auth";
import * as secretGetting from "@data-heaving/azure-kv-secret";
import * as pulumiAzure from "@data-heaving/pulumi-azure";
import * as events from "./events";
export interface Inputs {
  eventEmitter: events.BootstrapEventEmitter;
  credentials: auth.TokenCredential;
  azure: pulumiAzure.AzureCloudInformationFull;
  principalId: string;
  organization: OrganizationInfo;
  spAuthStorageConfig: SPAuthStorageConfig | undefined;
  pulumiEncryptionKeyBits: number;
}
export interface Outputs {
  cicdRGName: string;
  kvName: string;
  backendConfig: pulumiAzure.PulumiAzureBackendConfig;
  backendStorageAccountKey: string;
}
export interface OrganizationInfo {
  name: string;
  location: string;
}
export interface SPAuthStorageConfig {
  keyPEM: string;
  certPEM: string;
  configReaderPrincipalId: string;
  configSecretName: string;
}
export declare const ensureRequireCloudResourcesForPulumiStateExist: (
  inputs: Inputs,
) => Promise<Outputs>;
export declare const constructVaultName: (organization: string) => string;
export declare const tryGetSecretValue: (
  auth: auth.TokenCredential,
  secretReferenceOrURL: secretGetting.KevaultSecretReferenceOrURL,
) => Promise<string | undefined>;
