import * as t from "io-ts";
import * as id from "@azure/identity";
import * as graph from "@microsoft/microsoft-graph-client";
export interface BootstrappingCredentials {
  credentials: id.TokenCredential & graph.AuthenticationProvider;
  givenClientId: string | undefined;
}
export declare type UpsertResult<T> = T & {
  createNew: boolean;
};
export declare const applicationRequiredResourceAccess: t.TypeC<{
  resourceAppId: t.RefinementC<t.StringC>;
  resourceAccess: t.ArrayC<
    t.TypeC<{
      type: t.RefinementC<t.StringC>;
      id: t.RefinementC<t.StringC>;
    }>
  >;
}>;
export declare type ApplicationRequiredResourceAccess = t.TypeOf<
  typeof applicationRequiredResourceAccess
>;
export declare const applicationKeyCredential: t.TypeC<{
  customKeyIdentifier: t.RefinementC<t.StringC>;
  displayName: t.StringC;
  endDateTime: t.RefinementC<t.StringC>;
  key: t.UnionC<[t.NullC, t.StringC]>;
  keyId: t.RefinementC<t.StringC>;
  startDateTime: t.RefinementC<t.StringC>;
  type: t.UnionC<
    [t.LiteralC<"AsymmetricX509Cert">, t.LiteralC<"X509CertAndPassword">]
  >;
  usage: t.UnionC<[t.LiteralC<"Verify">, t.LiteralC<"Sign">]>;
}>;
export declare type ApplicationCredential = t.TypeOf<
  typeof applicationKeyCredential
>;
export declare const application: t.TypeC<{
  "@odata.id": t.RefinementC<t.StringC>;
  id: t.RefinementC<t.StringC>;
  appId: t.RefinementC<t.StringC>;
  displayName: t.StringC;
  keyCredentials: t.ArrayC<
    t.TypeC<{
      customKeyIdentifier: t.RefinementC<t.StringC>;
      displayName: t.StringC;
      endDateTime: t.RefinementC<t.StringC>;
      key: t.UnionC<[t.NullC, t.StringC]>;
      keyId: t.RefinementC<t.StringC>;
      startDateTime: t.RefinementC<t.StringC>;
      type: t.UnionC<
        [t.LiteralC<"AsymmetricX509Cert">, t.LiteralC<"X509CertAndPassword">]
      >;
      usage: t.UnionC<[t.LiteralC<"Verify">, t.LiteralC<"Sign">]>;
    }>
  >;
  requiredResourceAccess: t.ArrayC<
    t.TypeC<{
      resourceAppId: t.RefinementC<t.StringC>;
      resourceAccess: t.ArrayC<
        t.TypeC<{
          type: t.RefinementC<t.StringC>;
          id: t.RefinementC<t.StringC>;
        }>
      >;
    }>
  >;
}>;
export declare type Application = t.TypeOf<typeof application>;
export declare const servicePrincipal: t.TypeC<{
  "@odata.id": t.RefinementC<t.StringC>;
  id: t.RefinementC<t.StringC>;
  appId: t.RefinementC<t.StringC>;
  displayName: t.StringC;
  appRoles: t.ArrayC<
    t.TypeC<{
      id: t.RefinementC<t.StringC>;
      origin: t.StringC;
      value: t.RefinementC<t.StringC>;
      description: t.UnionC<[t.StringC, t.NullC]>;
      displayName: t.UnionC<[t.StringC, t.NullC]>;
    }>
  >;
}>;
export declare type ServicePrincipal = t.TypeOf<typeof servicePrincipal>;
export declare const servicePrincipalAppRoleAssignment: t.TypeC<{
  "@odata.id": t.RefinementC<t.StringC>;
  id: t.RefinementC<t.StringC>;
  appRoleId: t.RefinementC<t.StringC>;
  createdDateTime: t.RefinementC<t.StringC>;
  deletedDateTime: t.UnionC<[t.RefinementC<t.StringC>, t.NullC]>;
  principalDisplayName: t.StringC;
  principalId: t.RefinementC<t.StringC>;
  principalType: t.StringC;
  resourceDisplayName: t.StringC;
  resourceId: t.RefinementC<t.StringC>;
}>;
export declare type ServicePrincipalAppRoleAssignment = t.TypeOf<
  typeof servicePrincipalAppRoleAssignment
>;
export declare const AZURE_CLIENT_ID_ENV_NAME = "AZURE_CLIENT_ID";
