"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AZURE_CLIENT_ID_ENV_NAME = exports.servicePrincipalAppRoleAssignment = exports.servicePrincipal = exports.application = exports.applicationKeyCredential = exports.applicationRequiredResourceAccess = void 0;
const t = __importStar(require("io-ts"));
const validation = __importStar(require("@data-heaving/common-validation"));
exports.applicationRequiredResourceAccess = t.type({
    resourceAppId: validation.uuid,
    resourceAccess: t.array(t.type({
        type: validation.nonEmptyString,
        id: validation.uuid,
    }), "ResourceAccessList"),
}, "RequiredResourceAccess");
exports.applicationKeyCredential = t.type({
    customKeyIdentifier: validation.nonEmptyString,
    displayName: t.string,
    endDateTime: validation.isoDateString,
    key: t.union([t.null, t.string]),
    keyId: validation.uuid,
    startDateTime: validation.isoDateString,
    // The following two properties are actually discriminating type union properties, but let's handle that later if needed
    type: t.union([
        t.literal("AsymmetricX509Cert"),
        t.literal("X509CertAndPassword"),
    ]),
    usage: t.union([t.literal("Verify"), t.literal("Sign")]),
}, "KeyCredential");
exports.application = t.type({
    ["@odata.id"]: validation.urlWithPath,
    id: validation.uuid,
    appId: validation.uuid,
    displayName: t.string,
    keyCredentials: t.array(exports.applicationKeyCredential),
    requiredResourceAccess: t.array(exports.applicationRequiredResourceAccess, "RequiredResourceAccessList"),
    // And many others (e.g. passwordCredentials, but we don't use that (otherwise same as key credential, but without 'type' and 'usage', and 'hint' and 'secretText' instead ('secretText' and 'customKeyIdentifier' always null)))
}, "Application");
exports.servicePrincipal = t.type({
    ["@odata.id"]: validation.urlWithPath,
    id: validation.uuid,
    appId: validation.uuid,
    displayName: t.string,
    appRoles: t.array(t.type({
        id: validation.uuid,
        origin: t.string,
        value: validation.nonEmptyString,
        description: t.union([t.string, t.null]),
        displayName: t.union([t.string, t.null]),
        // allowedMemberTypes: t.array(t.string) <- "Application" | ...?
    }, "AppRole"), "AppRoleList"),
    // And many others
    // They include also 'keyCredentials', however, that is not used for logging in at least, so we don't touch those here.
}, "ServicePrincipal");
exports.servicePrincipalAppRoleAssignment = t.type({
    ["@odata.id"]: validation.urlWithPath,
    id: validation.nonEmptyString,
    appRoleId: validation.uuid,
    createdDateTime: validation.isoDateString,
    deletedDateTime: t.union([validation.isoDateString, t.null]),
    principalDisplayName: t.string,
    principalId: validation.uuid,
    principalType: t.string,
    resourceDisplayName: t.string,
    resourceId: validation.uuid,
});
exports.AZURE_CLIENT_ID_ENV_NAME = "AZURE_CLIENT_ID";
//# sourceMappingURL=types.js.map