import * as graph from "@microsoft/microsoft-graph-client";
import * as pulumi from "@data-heaving/pulumi-azure-pipeline-setup";
import * as events from "./events";
export interface Inputs {
  eventEmitter: events.BootstrapEventEmitter;
  graphClient: graph.Client;
  bootstrapperApp: {
    displayName: string;
    willNeedToCreateAADApps: boolean;
  };
  certificatePEM: string;
}
export declare const ensureBootstrapSPIsConfigured: ({
  eventEmitter,
  graphClient,
  bootstrapperApp: { displayName, willNeedToCreateAADApps },
  certificatePEM,
}: Inputs) => Promise<{
  clientId: string;
  principalId: string;
}>;
export declare const getCurrentPrincipalInfo: (
  graphClient: graph.Client,
  givenClientId: string | undefined,
) => Promise<pulumi.EnvSpecificPipelineConfigReader>;
